class Parameters(object):
    def __init__(self, *, p, q, g):
        if isinstance(p, bytes):
            p = int.from_bytes(p, 'big')
        self.p = p

        if isinstance(q, bytes):
            q = int.from_bytes(q, 'big')
        self.q = q

        if isinstance(q, bytes):
            g = int.from_bytes(g, 'big')
        self.g = g


NIST_80 = Parameters(
    p=(
        b'\xfd\x7f\x53\x81\x1d\x75\x12\x29\x52\xdf\x4a\x9c\x2e\xec\xe4\xe7'
        b'\xf6\x11\xb7\x52\x3c\xef\x44\x00\xc3\x1e\x3f\x80\xb6\x51\x26\x69'
        b'\x45\x5d\x40\x22\x51\xfb\x59\x3d\x8d\x58\xfa\xbf\xc5\xf5\xba\x30'
        b'\xf6\xcb\x9b\x55\x6c\xd7\x81\x3b\x80\x1d\x34\x6f\xf2\x66\x60\xb7'
        b'\x6b\x99\x50\xa5\xa4\x9f\x9f\xe8\x04\x7b\x10\x22\xc2\x4f\xbb\xa9'
        b'\xd7\xfe\xb7\xc6\x1b\xf8\x3b\x57\xe7\xc6\xa8\xa6\x15\x0f\x04\xfb'
        b'\x83\xf6\xd3\xc5\x1e\xc3\x02\x35\x54\x13\x5a\x16\x91\x32\xf6\x75'
        b'\xf3\xae\x2b\x61\xd7\x2a\xef\xf2\x22\x03\x19\x9d\xd1\x48\x01\xc7'
    ),
    q=(
        b'\x97\x60\x50\x8f\x15\x23\x0b\xcc\xb2\x92\xb9\x82\xa2\xeb\x84\x0b'
        b'\xf0\x58\x1c\xf5'
    ),
    g=(
        b'\xf7\xe1\xa0\x85\xd6\x9b\x3d\xde\xcb\xbc\xab\x5c\x36\xb8\x57\xb9'
        b'\x79\x94\xaf\xbb\xfa\x3a\xea\x82\xf9\x57\x4c\x0b\x3d\x07\x82\x67'
        b'\x51\x59\x57\x8e\xba\xd4\x59\x4f\xe6\x71\x07\x10\x81\x80\xb4\x49'
        b'\x16\x71\x23\xe8\x4c\x28\x16\x13\xb7\xcf\x09\x32\x8c\xc8\xa6\xe1'
        b'\x3c\x16\x7a\x8b\x54\x7c\x8d\x28\xe0\xa3\xae\x1e\x2b\xb3\xa6\x75'
        b'\x91\x6e\xa3\x7f\x0b\xfa\x21\x35\x62\xf1\xfb\x62\x7a\x01\x24\x3b'
        b'\xcc\xa4\xf1\xbe\xa8\x51\x90\x89\xa8\x83\xdf\xe1\x5a\xe5\x9f\x06'
        b'\x92\x8b\x66\x5e\x80\x7b\x55\x25\x64\x01\x4c\x3b\xfe\xcf\x49\x2a'
    ),
)


NIST_112 = Parameters(
    p=(
        b'\xC1\x96\xBA\x05\xAC\x29\xE1\xF9\xC3\xC7\x2D\x56\xDF\xFC\x61\x54'
        b'\xA0\x33\xF1\x47\x7A\xC8\x8E\xC3\x7F\x09\xBE\x6C\x5B\xB9\x5F\x51'
        b'\xC2\x96\xDD\x20\xD1\xA2\x8A\x06\x7C\xCC\x4D\x43\x16\xA4\xBD\x1D'
        b'\xCA\x55\xED\x10\x66\xD4\x38\xC3\x5A\xEB\xAA\xBF\x57\xE7\xDA\xE4'
        b'\x28\x78\x2A\x95\xEC\xA1\xC1\x43\xDB\x70\x1F\xD4\x85\x33\xA3\xC1'
        b'\x8F\x0F\xE2\x35\x57\xEA\x7A\xE6\x19\xEC\xAC\xC7\xE0\xB5\x16\x52'
        b'\xA8\x77\x6D\x02\xA4\x25\x56\x7D\xED\x36\xEA\xBD\x90\xCA\x33\xA1'
        b'\xE8\xD9\x88\xF0\xBB\xB9\x2D\x02\xD1\xD2\x02\x90\x11\x3B\xB5\x62'
        b'\xCE\x1F\xC8\x56\xEE\xB7\xCD\xD9\x2D\x33\xEE\xA6\xF4\x10\x85\x9B'
        b'\x17\x9E\x7E\x78\x9A\x8F\x75\xF6\x45\xFA\xE2\xE1\x36\xD2\x52\xBF'
        b'\xFA\xFF\x89\x52\x89\x45\xC1\xAB\xE7\x05\xA3\x8D\xBC\x2D\x36\x4A'
        b'\xAD\xE9\x9B\xE0\xD0\xAA\xD8\x2E\x53\x20\x12\x14\x96\xDC\x65\xB3'
        b'\x93\x0E\x38\x04\x72\x94\xFF\x87\x78\x31\xA1\x6D\x52\x28\x41\x8D'
        b'\xE8\xAB\x27\x5D\x7D\x75\x65\x1C\xEF\xED\x65\xF7\x8A\xFC\x3E\xA7'
        b'\xFE\x4D\x79\xB3\x5F\x62\xA0\x40\x2A\x11\x17\x59\x9A\xDA\xC7\xB2'
        b'\x69\xA5\x9F\x35\x3C\xF4\x50\xE6\x98\x2D\x3B\x17\x02\xD9\xCA\x83'
    ),
    q=(
        b'\x90\xEA\xF4\xD1\xAF\x07\x08\xB1\xB6\x12\xFF\x35\xE0\xA2\x99\x7E'
        b'\xB9\xE9\xD2\x63\xC9\xCE\x65\x95\x28\x94\x5C\x0D'
    ),
    g=(
        b'\xA5\x9A\x74\x9A\x11\x24\x2C\x58\xC8\x94\xE9\xE5\xA9\x18\x04\xE8'
        b'\xFA\x0A\xC6\x4B\x56\x28\x8F\x8D\x47\xD5\x1B\x1E\xDC\x4D\x65\x44'
        b'\x4F\xEC\xA0\x11\x1D\x78\xF3\x5F\xC9\xFD\xD4\xCB\x1F\x1B\x79\xA3'
        b'\xBA\x9C\xBE\xE8\x3A\x3F\x81\x10\x12\x50\x3C\x81\x17\xF9\x8E\x50'
        b'\x48\xB0\x89\xE3\x87\xAF\x69\x49\xBF\x87\x84\xEB\xD9\xEF\x45\x87'
        b'\x6F\x2E\x6A\x5A\x49\x5B\xE6\x4B\x6E\x77\x04\x09\x49\x4B\x7F\xEE'
        b'\x1D\xBB\x1E\x4B\x2B\xC2\xA5\x3D\x4F\x89\x3D\x41\x8B\x71\x59\x59'
        b'\x2E\x4F\xFF\xDF\x69\x69\xE9\x1D\x77\x0D\xAE\xBD\x0B\x5C\xB1\x4C'
        b'\x00\xAD\x68\xEC\x7D\xC1\xE5\x74\x5E\xA5\x5C\x70\x6C\x4A\x1C\x5C'
        b'\x88\x96\x4E\x34\xD0\x9D\xEB\x75\x3A\xD4\x18\xC1\xAD\x0F\x4F\xDF'
        b'\xD0\x49\xA9\x55\xE5\xD7\x84\x91\xC0\xB7\xA2\xF1\x57\x5A\x00\x8C'
        b'\xCD\x72\x7A\xB3\x76\xDB\x6E\x69\x55\x15\xB0\x5B\xD4\x12\xF5\xB8'
        b'\xC2\xF4\xC7\x7E\xE1\x0D\xA4\x8A\xBD\x53\xF5\xDD\x49\x89\x27\xEE'
        b'\x7B\x69\x2B\xBB\xCD\xA2\xFB\x23\xA5\x16\xC5\xB4\x53\x3D\x73\x98'
        b'\x0B\x2A\x3B\x60\xE3\x84\xED\x20\x0A\xE2\x1B\x40\xD2\x73\x65\x1A'
        b'\xD6\x06\x0C\x13\xD9\x7F\xD6\x9A\xA1\x3C\x56\x11\xA5\x1B\x90\x85'
    ),
)


NIST_128 = Parameters(
    p=(
        b'\x90\x06\x64\x55\xB5\xCF\xC3\x8F\x9C\xAA\x4A\x48\xB4\x28\x1F\x29'
        b'\x2C\x26\x0F\xEE\xF0\x1F\xD6\x10\x37\xE5\x62\x58\xA7\x79\x5A\x1C'
        b'\x7A\xD4\x60\x76\x98\x2C\xE6\xBB\x95\x69\x36\xC6\xAB\x4D\xCF\xE0'
        b'\x5E\x67\x84\x58\x69\x40\xCA\x54\x4B\x9B\x21\x40\xE1\xEB\x52\x3F'
        b'\x00\x9D\x20\xA7\xE7\x88\x0E\x4E\x5B\xFA\x69\x0F\x1B\x90\x04\xA2'
        b'\x78\x11\xCD\x99\x04\xAF\x70\x42\x0E\xEF\xD6\xEA\x11\xEF\x7D\xA1'
        b'\x29\xF5\x88\x35\xFF\x56\xB8\x9F\xAA\x63\x7B\xC9\xAC\x2E\xFA\xAB'
        b'\x90\x34\x02\x22\x9F\x49\x1D\x8D\x34\x85\x26\x1C\xD0\x68\x69\x9B'
        b'\x6B\xA5\x8A\x1D\xDB\xBE\xF6\xDB\x51\xE8\xFE\x34\xE8\xA7\x8E\x54'
        b'\x2D\x7B\xA3\x51\xC2\x1E\xA8\xD8\xF1\xD2\x9F\x5D\x5D\x15\x93\x94'
        b'\x87\xE2\x7F\x44\x16\xB0\xCA\x63\x2C\x59\xEF\xD1\xB1\xEB\x66\x51'
        b'\x1A\x5A\x0F\xBF\x61\x5B\x76\x6C\x58\x62\xD0\xBD\x8A\x3F\xE7\xA0'
        b'\xE0\xDA\x0F\xB2\xFE\x1F\xCB\x19\xE8\xF9\x99\x6A\x8E\xA0\xFC\xCD'
        b'\xE5\x38\x17\x52\x38\xFC\x8B\x0E\xE6\xF2\x9A\xF7\xF6\x42\x77\x3E'
        b'\xBE\x8C\xD5\x40\x24\x15\xA0\x14\x51\xA8\x40\x47\x6B\x2F\xCE\xB0'
        b'\xE3\x88\xD3\x0D\x4B\x37\x6C\x37\xFE\x40\x1C\x2A\x2C\x2F\x94\x1D'
        b'\xAD\x17\x9C\x54\x0C\x1C\x8C\xE0\x30\xD4\x60\xC4\xD9\x83\xBE\x9A'
        b'\xB0\xB2\x0F\x69\x14\x4C\x1A\xE1\x3F\x93\x83\xEA\x1C\x08\x50\x4F'
        b'\xB0\xBF\x32\x15\x03\xEF\xE4\x34\x88\x31\x0D\xD8\xDC\x77\xEC\x5B'
        b'\x83\x49\xB8\xBF\xE9\x7C\x2C\x56\x0E\xA8\x78\xDE\x87\xC1\x1E\x3D'
        b'\x59\x7F\x1F\xEA\x74\x2D\x73\xEE\xC7\xF3\x7B\xE4\x39\x49\xEF\x1A'
        b'\x0D\x15\xC3\xF3\xE3\xFC\x0A\x83\x35\x61\x70\x55\xAC\x91\x32\x8E'
        b'\xC2\x2B\x50\xFC\x15\xB9\x41\xD3\xD1\x62\x4C\xD8\x8B\xC2\x5F\x3E'
        b'\x94\x1F\xDD\xC6\x20\x06\x89\x58\x1B\xFE\xC4\x16\xB4\xB2\xCB\x73'
    ),
    q=(
        b'\xCF\xA0\x47\x8A\x54\x71\x7B\x08\xCE\x64\x80\x5B\x76\xE5\xB1\x42'
        b'\x49\xA7\x7A\x48\x38\x46\x9D\xF7\xF7\xDC\x98\x7E\xFC\xCF\xB1\x1D'
    ),
    g=(
        b'\x5E\x5C\xBA\x99\x2E\x0A\x68\x0D\x88\x5E\xB9\x03\xAE\xA7\x8E\x4A'
        b'\x45\xA4\x69\x10\x3D\x44\x8E\xDE\x3B\x7A\xCC\xC5\x4D\x52\x1E\x37'
        b'\xF8\x4A\x4B\xDD\x5B\x06\xB0\x97\x0C\xC2\xD2\xBB\xB7\x15\xF7\xB8'
        b'\x28\x46\xF9\xA0\xC3\x93\x91\x4C\x79\x2E\x6A\x92\x3E\x21\x17\xAB'
        b'\x80\x52\x76\xA9\x75\xAA\xDB\x52\x61\xD9\x16\x73\xEA\x9A\xAF\xFE'
        b'\xEC\xBF\xA6\x18\x3D\xFC\xB5\xD3\xB7\x33\x2A\xA1\x92\x75\xAF\xA1'
        b'\xF8\xEC\x0B\x60\xFB\x6F\x66\xCC\x23\xAE\x48\x70\x79\x1D\x59\x82'
        b'\xAA\xD1\xAA\x94\x85\xFD\x8F\x4A\x60\x12\x6F\xEB\x2C\xF0\x5D\xB8'
        b'\xA7\xF0\xF0\x9B\x33\x97\xF3\x93\x7F\x2E\x90\xB9\xE5\xB9\xC9\xB6'
        b'\xEF\xEF\x64\x2B\xC4\x83\x51\xC4\x6F\xB1\x71\xB9\xBF\xA9\xEF\x17'
        b'\xA9\x61\xCE\x96\xC7\xE7\xA7\xCC\x3D\x3D\x03\xDF\xAD\x10\x78\xBA'
        b'\x21\xDA\x42\x51\x98\xF0\x7D\x24\x81\x62\x2B\xCE\x45\x96\x9D\x9C'
        b'\x4D\x60\x63\xD7\x2A\xB7\xA0\xF0\x8B\x2F\x49\xA7\xCC\x6A\xF3\x35'
        b'\xE0\x8C\x47\x20\xE3\x14\x76\xB6\x72\x99\xE2\x31\xF8\xBD\x90\xB3'
        b'\x9A\xC3\xAE\x3B\xE0\xC6\xB6\xCA\xCE\xF8\x28\x9A\x2E\x28\x73\xD5'
        b'\x8E\x51\xE0\x29\xCA\xFB\xD5\x5E\x68\x41\x48\x9A\xB6\x6B\x5B\x4B'
        b'\x9B\xA6\xE2\xF7\x84\x66\x08\x96\xAF\xF3\x87\xD9\x28\x44\xCC\xB8'
        b'\xB6\x94\x75\x49\x6D\xE1\x9D\xA2\xE5\x82\x59\xB0\x90\x48\x9A\xC8'
        b'\xE6\x23\x63\xCD\xF8\x2C\xFD\x8E\xF2\xA4\x27\xAB\xCD\x65\x75\x0B'
        b'\x50\x6F\x56\xDD\xE3\xB9\x88\x56\x7A\x88\x12\x6B\x91\x4D\x78\x28'
        b'\xE2\xB6\x3A\x6D\x7E\xD0\x74\x7E\xC5\x9E\x0E\x0A\x23\xCE\x7D\x8A'
        b'\x74\xC1\xD2\xC2\xA7\xAF\xB6\xA2\x97\x99\x62\x0F\x00\xE1\x1C\x33'
        b'\x78\x7F\x7D\xED\x3B\x30\xE1\xA2\x2D\x09\xF1\xFB\xDA\x1A\xBB\xBF'
        b'\xBF\x25\xCA\xE0\x5A\x13\xF8\x12\xE3\x45\x63\xF9\x94\x10\xE7\x3B'
    ),
)
